package respro.universaleb;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Iterator;
import java.util.Set;
import java.util.TreeMap;

public class Analysis {
	public void analyse() {
		System.out
				.println("loading benchmark data file(result.log), please wait...\n");
		File resultLog = new File("result.log");
		if (!resultLog.exists()) {
			System.out.println("I can not find benchmark data file result.log");
			System.out
					.println("in the current directory, do you remove it or ");
			System.out.println("do the analysis before performance test?");
			System.exit(0);
		}
		System.out.println("benchmark data file loaded, begin analysis...");
		BufferedReader bf;
		try {
			bf = new BufferedReader(new FileReader("result.log"));
			String currentLine = bf.readLine();
			TreeMap<String, Integer> ht = new TreeMap<String, Integer>();
			while (currentLine != null) {
				String[] cols = currentLine.split(" ");
				cols[1] = cols[1].substring(0, cols[1].lastIndexOf(":"));
				String dateTime = cols[0] + " " + cols[1];
				Integer count = ht.get(dateTime);
				if (count == null) {
					ht.put(dateTime, Integer.valueOf(1));
				} else {
					count = count + 1;
					ht.put(dateTime, count);
				}
				currentLine = bf.readLine();
			}
			System.out.println("analysis finished, please refer to the file"
					+ " \"throughput.log\" for detail");
			File throughput = new File("throughtput.log");
			if (throughput.exists()) {
				throughput.delete();
			}
			FileWriter fw = new FileWriter("throughtput.log");
			BufferedWriter bw = new BufferedWriter(fw);
			Set<String> keySet = ht.keySet();
			Iterator<String> iter = keySet.iterator();
			while (iter.hasNext()) {
				String key = iter.next();
				bw.write(key + "\t");
				bw.write(ht.get(key) + "\n");
			}
			bw.flush();
			bw.close();
			fw.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
