package respro.universaleb;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class AnalysisBPEL {
	public static void main(String[] args) {
		new AnalysisBPEL().analyse("result10.log");
	}

	public void analyse(String fileName) {
		System.out
				.println("loading benchmark data file(result.log), please wait...\n");
		File resultLog = new File(fileName);
		if (!resultLog.exists()) {
			System.out
					.println("I can not find benchmark data file " + fileName);
			System.out
					.println("in the current directory, do you remove it or ");
			System.out.println("do the analysis before performance test?");
			System.exit(0);
		}
		System.out.println("benchmark data file loaded, begin analysis...");
		BufferedReader bf;
		try {
			File original = new File(fileName + ".original");
			if (original.exists()) {
				original.delete();
			}
			File req = new File(fileName + ".req");
			if (req.exists()) {
				req.delete();
			}
			File resp = new File(fileName + ".resp");
			if (resp.exists()) {
				resp.delete();
			}
			File su = new File(fileName + ".su");
			if (su.exists()) {
				su.delete();
			}
			FileWriter fwOriginal = new FileWriter(fileName + ".original");
			BufferedWriter bwOriginal = new BufferedWriter(fwOriginal);
			FileWriter fwReq = new FileWriter(fileName + ".req");
			BufferedWriter bwReq = new BufferedWriter(fwReq);
			FileWriter fwResp = new FileWriter(fileName + ".resp");
			BufferedWriter bwResp = new BufferedWriter(fwResp);
			FileWriter fwSU = new FileWriter(fileName + ".su");
			BufferedWriter bwSU = new BufferedWriter(fwSU);
			bf = new BufferedReader(new FileReader(fileName));
			String currentLine = bf.readLine();
			while (currentLine != null) {
				String[] cols = currentLine.split(",");
				if (cols[2].equals("O")) {
					bwOriginal.write(currentLine + "\n");
				} else if (cols[2].equals("Req")) {
					bwReq.write(currentLine + "\n");
				} else if (cols[2].equals("Resp")) {
					bwResp.write(currentLine + "\n");
				} else if (cols[2].equals("SU")) {
					bwSU.write(currentLine + "\n");
				}
				currentLine = bf.readLine();
			}
			bwOriginal.flush();
			bwOriginal.close();
			fwOriginal.close();
			bwReq.flush();
			bwReq.close();
			fwReq.close();
			bwResp.flush();
			bwResp.close();
			fwResp.close();
			bwSU.flush();
			bwSU.close();
			fwSU.close();
			System.out.println("analysis finished.");
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
