package respro.universaleb;

import java.io.File;

public class Clients {
	protected WorkBenchRunner wbr;

	public static void main(String[] args) throws InterruptedException {
		if (args.length == 0
				|| (args.length != 2 && !(args[0].equals("analyse")))) {
			System.out
					.println("usage:		java -jar benchmark.jar [urlOfServerBenchmark workloadFileName] | [analyse]\n"
							+ "for example:	java -jar benchmark.jar http://192.168.10.13/php-benchmark.php /home/wl/workBenchFile\n"
							+ "		Use the above command to collect performance data firstly.\n"
							+ "then use:	java -jar benchmark.jar analyse\n"
							+ "		After collecting performance data, use this command to analyse.\n"
							+ "Before collectiong benchmark data you need editing a workloadFile as the \n"
							+ "second parameter \"wordloadFileName\" to collect performance data. Edit the\n"
							+ "workloadFile as the following.\n"
							+ "workloadFile specification:\n"
							+ "The first line is the total minutes that you want the test lasts.\n"
							+ "If the value equals 5, it means that you want the program running \n"
							+ "for five minutes and there must be 5 lines in the following specifies\n"
							+ "how heavy the workload is for every minutes. The the request coming\n"
							+ "distribution yields to Poisson distribution and the value you enter\n"
							+ "here is the expectation of the distribution as well as the average \n"
							+ "number of requirements you want to send to the server, here is a demo\n"
							+ "workBenchFile:\n"
							+ "5\n"
							+ "100\n"
							+ "200\n"
							+ "300\n"
							+ "400\n"
							+ "500\n"
							+ "After collecting benchmark data:\n"
							+ "	see result.log for test result of the benchmark data.\n"
							+ "After doing your analysis:\n"
							+ "	see throughput.log for the server throughput for every minute of the test.\n");
			System.exit(0);
		}
		if (args[0].equals("analyse")) {
			new Analysis().analyse();
			System.exit(0);
		}
		File resultFile = new File("result.log");
		if (resultFile.exists()) {
			resultFile.delete();
		}
		File configFile = new File("config");
		if (configFile.exists()) {
			configFile.delete();
		}
		Clients myclients = new Clients(args[1]);
		myclients.wbr.runBench(args[0]);
	}

	public Clients(String workbenchfile) {
		wbr = new WorkBenchRunner(workbenchfile);
	}
}
