package respro.universaleb;

import java.io.BufferedReader;
import java.io.FileReader;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import org.apache.log4j.PropertyConfigurator;

public class WorkBenchRunner extends Thread {
	private int[] numpmin;

	public WorkBenchRunner(String WorkBench) {
		loadBench(WorkBench);
		PropertyConfigurator.configure("log.cfg");
	}

	private void loadBench(String BenchFile) {
		try {
			BufferedReader bf = new BufferedReader(new FileReader(BenchFile));
			int totalnum = new Integer(bf.readLine());
			numpmin = new int[totalnum];
			for (int i = 0; i < totalnum; i++) {
				numpmin[i] = new Integer(bf.readLine());
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void runBench(String URL) throws InterruptedException {
		int time = 0;
		long realtime = System.currentTimeMillis();
		ExecutorService executor = Executors.newCachedThreadPool();
		System.out.println("test begins...");
		while (time < numpmin.length) {
			if (System.currentTimeMillis() < realtime) {
				try {
					sleep(realtime - System.currentTimeMillis());
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
			}
			int temp = 0;
			int now = 0;

			while (temp < 60000) {
				now = (int) (-60000 * Math.log(Math.random()) / numpmin[time]);
				sleep(now);
				temp += now;
				// temp=(int)(invoketime-System.currentTimeMillis());
				executor.execute(new EmulateBrowser(URL, temp));
			}
			time++;
			realtime += 60000;
			System.out
					.println("the test has passed for " + time + " minute(s)");
		}
		executor.shutdown();
	}
}
